package bytecode;

import static org.junit.Assert.*;

import java.io.File;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

import org.junit.BeforeClass;
import org.junit.Test;

import de.dhbwstuttgart.core.JavaTXCompiler;

public class PlusTest {
	private static String path;
	private static File fileToTest;
	private static JavaTXCompiler compiler;
	private static ClassLoader loader;
	private static Class<?> classToTest;
	private static String pathToClassFile;
	private static Object instanceOfClass;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		path = System.getProperty("user.dir")+"/src/test/resources/bytecode/javFiles/Plus.jav";
		fileToTest = new File(path);
		compiler = new JavaTXCompiler(fileToTest);
		pathToClassFile = System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/";
		compiler.generateBytecode(pathToClassFile);
		loader = new URLClassLoader(new URL[] {new URL("file://"+pathToClassFile)});
		classToTest = loader.loadClass("Plus");
		instanceOfClass = classToTest.getDeclaredConstructor().newInstance();
	}

	@Test
	public void testAddInt() throws NoSuchMethodException, SecurityException, IllegalAccessException, 
						IllegalArgumentException, InvocationTargetException, InstantiationException {
		Method addInt = classToTest.getDeclaredMethod("m", Integer.class,Integer.class);
		Number result = (Number) addInt.invoke(instanceOfClass, 7,3);
		assertEquals(10, result);
	}
	
	@Test
	public void testAddString() throws NoSuchMethodException, SecurityException, IllegalAccessException, 
						IllegalArgumentException, InvocationTargetException, InstantiationException {
		Method addString = classToTest.getDeclaredMethod("m", String.class,String.class);
		String result = (String) addString.invoke(instanceOfClass, "Byte","Code");
		assertEquals("ByteCode", result);
	}

}
